{*************************************************************}
{*                Unit WinVer v1.02                          *}
{*    Copyright (c) 1998 by Dmitry Beloshistov [-=BDS=-]     *}
{*           Test operation system version                   *}
{*************************************************************}
Unit WinVer;
{$F+,O+,V-}

Interface

{$IFDEF DPMI}
Function IsWinNT:boolean;
{$ENDIF}
Procedure WinVersion(var Version,Revision:byte);
Procedure DosVersion(var Version,Revision:byte);
Function InWindows:boolean;
Function Win9xNT:boolean;
Function LongNameSupport:boolean;
Function WinNTDetect:boolean;
Function IsOS2:boolean;
Procedure GetOS2Version(var Version,Revision:byte);
Function DosLocation:Byte;

Implementation
{$IFDEF DPMI}
Uses WinApi;

Function IsWinNT:boolean;
begin
 IsWinNT:=((GetWinFlags and $4000)<>0);
end;
{$ENDIF}

Function LongNameSupport:boolean; assembler;
asm
 mov ax,714fh
 mov bx,0FFFFh        {ffffh handle}
 int 21h
 cmp ax,7100h
 je @no_support
 mov ax,true
 jmp @end_detect
@no_support:
 mov ax,false
@end_detect:
end;

Function WinNTDetect:boolean; assembler;
asm
  mov AX, 3306h        {Win/NT detect}
  int 21h
  xor ax,ax            {ax=0}
  cmp BX, 3205h
  jne @NOT_NT
  mov ax,true          {ErrorLevel=1  NT PRESENT}
  jmp @finish
@NOT_NT:
  mov ax,false         {ErrorLevel=0  NT ABSENT}
@FINISH:
end;

Function GetWinVer:Word; assembler;
asm
  mov     ax,4680h
  int     2Fh
  xor     al,80h
  mov     cl,al
  mov     ax,1600h
  int     2Fh
  xchg    ah,al {in HiByte - version, in LoByte - revision}
end;

Procedure WinVersion(var Version,Revision:byte);
{get Windows version}
begin
{$IFDEF DPMI}
 Version:=LoByte(LoWord(GetVersion));
 Revision:=HiByte(LoWord(GetVersion));
{$ELSE}
 Revision:=0;
 if InWindows then
  begin
   if not(LongNameSupport) and not(WinNTDetect) then
    begin
      Version:=Hi(GetWinVer);
      Revision:=Lo(GetWinVer);
    end
   else if LongNameSupport then Version:=95 {Windows 95/98}
        else Version:=4;                    {Windows NT}
  end
 else Version:=0;
{$ENDIF}
end;

Procedure DosVersion(var Version,Revision:byte);
{---- get Dos version -------}
{$IFNDEF DPMI}
var V,R:Byte;
{$ENDIF}
begin
{$IFDEF DPMI}
 Version:=HiByte(HiWord(GetVersion));
 Revision:=LoByte(HiWord(GetVersion));
{$ELSE}
 asm
    mov ax,3306h
    int 21h
    mov V,bl
    mov R,bh
 end;
 Version:=V; Revision:=R;
{$ENDIF}
end;

Function DosLocation:byte; assembler;
asm
    mov ax,3306h
    int 21h
    test dh,08h   {Dos in ROM}
    jnz  @@1
    test dh,10h   {DOS in HMA}
    jnz  @@2
    mov  ax,0     {in conversional memory}
    jmp  @@3
@@1:
    mov  ax,1     {in ROM area}
    jmp  @@3
@@2:
    mov  ax,2     {in HMA}
@@3:
end;

Function InWindows:boolean; assembler;
{it is DosSession in Explorer or protected mode only?}
asm
    mov ax,1600h
    int 2fh
    cmp al,0
    je @@1
    cmp al,80h
    je @@1
    mov ax,True {Windows installed}
    jmp @@2
@@1:           {Windows no installed}
    mov ax,False
@@2:
end;

Function Win9xNT:boolean;
{it is Win`9x or Win NT system?}
begin
 if WinNTDetect then Win9xNT:=true
 else Win9xNT:=LongNameSupport or WinNTDetect;
end;

Procedure GetOS2Version(var Version,Revision:Byte);
var OS2Ver:Word;
begin
 OS2Ver:=0;
asm
    mov   ax, 4010h
    int   2Fh
    cmp   ax, 4010h
    je    @NotOS2session
    mov   Os2Ver,bx
@NotOS2session:
end;
 Version:=Hi(Os2Ver);
 Revision:=Lo(Os2Ver);
End;

Function IsOS2:boolean; assembler;
asm
    mov   ax, 4010h
    int   2Fh
    cmp   ax, 4010h
    je    @NotOS2session
    mov   ax,TRUE
    jmp   @EndDetect
@NotOS2session:
    mov  ax,FALSE
@EndDetect:
end;

end.